﻿import mx.utils.Delegate;
import mx.controls.Alert;
class Bureau {
	private var scene:MovieClip;
	private var monShare:SharedObject;
	private var buro:MovieClip;
	private var fondCl:MovieClip;
	private var fondImg:MovieClip;
	public var param:Object;
	private var mesIcones:XML;
	public var img:String;
	public static var FENETREPROF:Number;
	public static var ESPACEICONE:Number = 90;
	public static var TAILLEICONE:Number = 50;
	public static var NOMBRECOL:Number = 5;
	public function Bureau(scen:MovieClip) {
		scene = scen;
		monShare = SharedObject.getLocal("nyros");
		param = new Object();
		if (monShare.data.param == null) {
			// Aucun sauvegarde de paramètres du bureau, on initialise les valeurs.
			param.fondCl = "333333";
			param.fondClAlpha = 50;
			param.fondImg = "images/04.jpg";
			param.dateDiff = 0;
		} else {
			// On remet ses préférences
			param.fondCl = monShare.data.param.fondCl;
			param.fondClAlpha = monShare.data.param.fondClAlpha;
			param.fondImg = monShare.data.param.fondImg;
			param.dateDiff = monShare.data.param.dateDiff;
		}
		if (monShare.data.dejavu == null) {
			// Première visite
			Alert.show("Pour naviguer, cliquer sur les icônes.\nEt penser au clic droit sur le Bureau !\nBonne visite.", "Bienvenue sur NyrOS !", Alert.OK);
			monShare.data.dejavu = 1;
			monShare.flush();
		}
		// Création du bureau
		scene.createEmptyMovieClip("bureau", 1);
		buro = eval(scene+".bureau");
		buro._x = 0;
		buro._y = 0;
		// Création de l'image de fond
		buro.createEmptyMovieClip("fondImg", 2);
		fondImg = eval(buro+".fondImg");
		fondImg._x = 0;
		fondImg._y = 0;
		changefond();
		// Chargement des icones
		mesIcones = new XML();
		mesIcones.ignoreWhite = true;
		// Ici on dit que notre onload sera la fonction chargementIcones
		//		de note objet bureau, via Delegate.create
		mesIcones.onLoad = Delegate.create(this, chargementIcones);
		mesIcones.load("icones/icones.xml");
		var sonClic:Sound = new Sound();
		sonClic.loadSound("clic-icone.mp3", false);
		sonClic.setVolume(100);
		Icone.sonClic = sonClic;
	}
	private function changefond(Void):Void {
		var cl:String = param.fondCl;
		_global.style.setStyle("themeColor", "0x"+cl);
		var alpha:Number = param.fondClAlpha;
		buro.createEmptyMovieClip("fondCl", 3);
		fondCl = eval(buro+".fondCl");
		fondCl._x = 0;
		fondCl._y = 0;
		with (fondCl) {
			moveTo(0, 0);
			linestyle(0, "0x"+cl, alpha);
			beginFill("0x"+cl, alpha);
			lineTo(800, 0);
			lineTo(800, 600);
			lineTo(0, 600);
			endFill();
		}
		if (img != param.fondImg) {
			// Il y a changement d'image de fond, on recharge
			img = param.fondImg;
			fondImg.loadMovie(img);
		}
	}
	private function chargementIcones(succes:Boolean):Void {
		if (succes) {
			var monIcone:XMLNode = mesIcones.firstChild;
			var col:Number = 0;
			var lin:Number = 0;
			for (var i = 0; i<monIcone.childNodes.length; i++) {
				var objInit:Object = new Object();
				if (i%NOMBRECOL == 0 && i>0) {
					col++;
					lin = 0;
				}
				objInit._x = col*ESPACEICONE+30+TAILLEICONE/2;
				objInit._y = lin*ESPACEICONE+30+TAILLEICONE/2;
				buro.attachMovie("icone", "icone"+i, 10+i, objInit);
				eval(buro+".icone"+i).init(monIcone.childNodes[i].attributes.nom, monIcone.childNodes[i].attributes.icone, monIcone.childNodes[i].attributes.swf, monIcone.childNodes[i].attributes.haut, monIcone.childNodes[i].attributes.larg);
				lin++;
			}
			FENETREPROF = 10+i+1;
		} else {
			trace("Erreur de chargement du xml des icones.");
		}
	}
	public function setParam(cl:String, alpha:Number, fond:String):Void {
		param.fondCl = cl;
		param.fondClAlpha = alpha;
		param.fondImg = fond;
		changefond();
	}
	public function setParamDate(diff:Number):Void {
		param.dateDiff = diff;
	}
	public function saveParam(Void):Void {
		monShare.data.param = param;
		monShare.flush();
	}
}
