﻿// Pour pouvoir faire un écouteur 
import mx.events.EventDispatcher;
import mx.controls.Button;
class ChxCouleur extends MovieClip {
	private var dispatchEvent:Function;
	private var dispatchQueue:Function;
	public var addEventListener:Function;
	public var removeEventListener:Function;
	private var scene:MovieClip;
	private var couleur:MovieClip;
	private var couleurs:MovieClip;
	private var cadreCl:MovieClip;
	private var clActuelle:String;
	private static var TAILLE:Number = 15;
	private static var NBLIN:Number = 18;
	private static var HAUTVOIR:Number = 18;
	private static var LARGVOIR:Number = 18;
	private static var POSYVOIR:Number = 185;
	public function ChxCouleur(scen:MovieClip, posX:Number, posY:Number, clAct:String) {
		// Initialisation pour l'écouteur
		mx.events.EventDispatcher.initialize(this);
		scene = scen;
		clActuelle = clAct;
		// Création du clip pour les couleurs
		scene.createEmptyMovieClip("couleur", 1);
		couleur = eval(scene+".couleur");
		couleur._x = posX;
		couleur._y = posY;
		couleur.cetObjet = this;
		couleur.createEmptyMovieClip("couleurs", 2);
		couleurs = eval(couleur+".couleurs");
		// Création de tous mes carrés de couleur
		var ligne:Number = 0;
		var colonne:Number = 0;
		var maCol:String;
		var act:Number = 0;
		for (var r = 0; r<256; r=r+51) {
			for (var v = 0; v<256; v=v+51) {
				for (var b = 0; b<256; b=b+51) {
					maCol = formatHex(r)+formatHex(v)+formatHex(b);
					if (colonne>NBLIN-1) {
						ligne++;
						colonne = 0;
					}
					traceCarre(maCol, ligne, colonne, act);
					colonne++;
					act++;
				}
			}
		}
		// Création du champ texte
		couleur.createTextField("affichage_txt", 3, LARGVOIR+5, POSYVOIR, 50, TAILLE+5);
		couleur.affichage_txt.type = "input";
		couleur.affichage_txt.textColor = 0x000000;
		couleur.affichage_txt.background = 0xFFFFFF;
		couleur.affichage_txt.border = true;
		couleur.affichage_txt.restrict = "a-f A-F 0-9";
		couleur.affichage_txt.maxChars = 6;
		couleur.affichage_txt.text = clAct;
		couleur.affichage_txt.onChanged = chgText;
		// on définit la fonction traceVoir de couleur identique à traceVoir de notre objet
		couleur.traceVoir = traceVoir;
		// idem pour valider et choisi
		couleur.valider = valider;
		couleur.choisi = choisi;
		// Création du cadre pour voir la couleur sélectionnée
		couleur.createEmptyMovieClip("cadreCl", 4);
		cadreCl = eval(couleur+".cadreCl");
		cadreCl._x = 0;
		cadreCl._y = POSYVOIR;
		couleur.traceVoir();
		var initObj:Object = new Object();
		initObj.label = "Valider";
		initObj._x = LARGVOIR+5+100;
		initObj._y = POSYVOIR;
		initObj._width = 60;
		initObj.onRelease = function() {
			this._parent.cetObjet.choisi(this._parent.affichage_txt.text);
		};
		couleur.createClassObject(Button, "valider_btn", 5, initObj);
		var initObj:Object = new Object();
		initObj.label = "Annuler";
		initObj._x = LARGVOIR+5+100+80;
		initObj._y = POSYVOIR;
		initObj._width = 60;
		initObj.onRelease = function() {
			this._parent.cetObjet.annuler();
		};
		couleur.createClassObject(Button, "annuler_btn", 6, initObj);
	}
	private function formatHex(num:String):String {
		num = num.toString(16);
		if (num.length == 1) {
			num = "0"+num;
		}
		return num;
	}
	private function traceCarre(cl:String, ligne:Number, colonne:Number, act:Number):Void {
		couleurs.createEmptyMovieClip("cl"+act, 10+act);
		var mAct:MovieClip = eval(couleurs+".cl"+act);
		mAct._x = colonne*TAILLE;
		mAct._y = ligne*TAILLE;
		mAct.couleur = cl;
		var maCl:Number = parseInt(cl, 16);
		mAct.moveTo(0, 0);
		mAct.lineStyle(0, maCl, 100);
		mAct.beginFill(maCl, 100);
		mAct.lineTo(TAILLE, 0);
		mAct.lineTo(TAILLE, TAILLE);
		mAct.lineTo(0, TAILLE);
		mAct.endFill();
		mAct.onRollOver = affCl;
		mAct.onRelease = choixClic;
	}
	private function chgText() {
		this._parent.affichage_txt.text = this._parent.affichage_txt.text.toUpperCase();
		this._parent.traceVoir();
	}
	private function affCl(Void):Void {
		this._parent._parent.affichage_txt.text = this.couleur.toUpperCase();
		this._parent._parent.traceVoir();
	}
	private function choixClic(Void):Void {
		this._parent._parent.valider(this.couleur);
	}
	private function traceVoir(Void):Void {
		var maCl:Number = parseInt(this._parent.couleur.affichage_txt.text, 16);
		cadreCl.moveTo(0, 0);
		cadreCl.lineStyle(0, 0x000000, 100);
		cadreCl.beginFill(maCl, 100);
		cadreCl.lineTo(LARGVOIR, 0);
		cadreCl.lineTo(LARGVOIR, HAUTVOIR);
		cadreCl.lineTo(0, HAUTVOIR);
		cadreCl.endFill();
	}
	private function valider(cl:String):Void {
		this._parent.couleur.cetObjet.choisi(cl);
	}
	private function annuler(Void):Void {
		choisi(clActuelle);
	}
	private function choisi(cl:String):Void {
		// Préparation de l'objet pour envoyer notre Evt
		var objEvt:Object = new Object();
		// Nom de l'évenement
		objEvt.type = "choix";
		objEvt.target = this;
		// Variable supplémantaire
		objEvt.couleur = cl;
		// Envoi de l'Evt !
		dispatchEvent(objEvt);
		// Suppression du clip créé pour le choix des couleurs
		couleur.removeMovieClip();
	}
}
