﻿import mx.utils.Delegate;
class Musique {
	private var scene:MovieClip;
	private var mesMusiques:Array;
	private var zikAct:Number;
	private var monLoadPHP:XML;
	public function Musique(scen:MovieClip) {
		scene = scen;
		var initObj:Object = new Object();
		// Paramètre pour le MediaDisplay
		initObj._x = 0;
		initObj._y = 0;
		initObj._width = 300;
		initObj._height = 10;
		initObj.mediaType = "MP3";
		scene.attachMovie("MediaPlayBack", "monPlayer", 1, initObj);
		zikAct = 0;
		monLoadPHP = new XML();
		monLoadPHP.ignoreWhite = true;
		monLoadPHP.load("listMP3.php");
		// Ici on dit que notre onLoad sera la fonction loadList
		//		de notre objet Musique, via Delegate.create
		monLoadPHP.onLoad = Delegate.create(this, loadList);
		scene.monPlayer.autoPlay = false;
		var monEcouteur:Object = new Object();
		// Ici on dit que notre onComplete sera la fonction recharge
		//		de notre objet Musique, via Delegate.create
		monEcouteur.complete = Delegate.create(this, recharge);
		scene.monPlayer.addEventListener("complete", monEcouteur);
	}
	private function loadList(succes:Boolean):Void {
		if (succes) {
			mesMusiques = monLoadPHP.firstChild.childNodes;
			recharge();
		} else {
			trace("Erreur de chargement.");
		}
	}
	private function recharge(Evt:Object):Void {
		if (mesMusiques[zikAct].firstChild.nodeValue == undefined) {
			zikAct = 0;
		}
		scene.monPlayer.setMedia(mesMusiques[zikAct].firstChild.nodeValue, "MP3");
		scene.monPlayer.play();
		zikAct++;
	}
}
