﻿import mx.utils.Delegate;
import mx.controls.Button;
class ParamBureau {
	private var scene:MovieClip;
	public var clActuelle:String;
	public var alphaActuel:Number;
	public var fondActuel:String;
	private var loadImages:XML;
	public function ParamBureau(scen:MovieClip, cl:String, alpha:Number, fond:String) {
		scene = scen;
		clActuelle = cl;
		alphaActuel = alpha;
		fondActuel = fond;
		creerElementFixe();
	}
	private function creerElementFixe(Void):Void {
		// Création du fond de couleur gris
		scene.createEmptyMovieClip("fondGris", 1);
		var fondGris:MovieClip = eval(scene+".fondGris");
		var cl:String = "A0A0A0";
		with (fondGris) {
			moveTo(0, 0);
			lineStyle(0, "0x"+cl, 100);
			beginFill("0x"+cl, 100);
			lineTo(300, 0);
			lineTo(300, 400);
			lineTo(0, 400);
			endFill();
		}
		// Création du texte pr la couleur
		scene.createTextField("couleur_txt", 2, 20, 10, 145, 20);
		scene.couleur_txt.textColor = "0xFFFFFF";
		scene.couleur_txt.selectable = false;
		scene.couleur_txt.text = "Choix de la couleur de filtre :";
		// Création du bouton pour choisir la couleur
		scene.createEmptyMovieClip("chxCol_mc", 3);
		scene.chxCol_mc._x = 170;
		scene.chxCol_mc._y = 10;
		scene.chxCol_mc.clAct = clActuelle;
		var monEcouteur:Object = new Object();
		// Ici on dit que notre choix sera la fonction newColor
		//		de notre objet Param, via Delegate.create
		monEcouteur.choix = Delegate.create(this, newColor);
		scene.chxCol_mc.onRelease = function(Void) {
			this._parent.createEmptyMovieClip("choix", 100);
			var choix:MovieClip = eval(this._parent+".choix");
			var maCouleur:ChxCouleur = new ChxCouleur(choix, 15, 50, this.clAct);
			maCouleur.addEventListener("choix", monEcouteur);
		};
		// Création du texte pr l'alpha
		scene.createTextField("alpha_txt", 4, 20, 40, 145, 20);
		scene.alpha_txt.textColor = "0xFFFFFF";
		scene.alpha_txt.selectable = false;
		scene.alpha_txt.text = "Choix de l'alpha de filtre :";
		// Création du NumericStepper pour l'alpha
		var initObj:Object = new Object();
		initObj._x = 170;
		initObj._y = 40;
		initObj._width = 58;
		initObj._height = 22;
		initObj.maximum = 100;
		initObj.value = alphaActuel;
		scene.attachMovie("NumericStepper", "alphaRegl", 5, initObj);
		// Ici on dit que notre change sera la fonction newAlpha
		//		de notre objet Param, via Delegate.create
		monEcouteur.change = Delegate.create(this, newAlpha);
		scene.alphaRegl.addEventListener("change", monEcouteur);
		// Création du texte pr l'image
		scene.createTextField("image_txt", 6, 20, 70, 145, 20);
		scene.image_txt.textColor = "0xFFFFFF";
		scene.image_txt.selectable = false;
		scene.image_txt.text = "Choix de l'image de fond :";
		// Création de la List pour l'image
		var initObj:Object = new Object();
		initObj._x = 20;
		initObj._y = 90;
		initObj._width = 250;
		initObj._height = 90;
		scene.attachMovie("List", "chxImage", 7, initObj);
		// Ici on dit que notre change sera la fonction newImage
		//		de notre objet Param, via Delegate.create
		var monEcouteur2:Object = new Object();
		monEcouteur2.change = Delegate.create(this, newImage);
		scene.chxImage.addEventListener("change", monEcouteur2);
		loadImages = new XML();
		loadImages.ignoreWhite = true;
		loadImages.load("images/fonds.xml");
		// Ici on dit que notre onLoad sera la fonction chargeXML
		//		de notre objet Param, via Delegate.create
		loadImages.onLoad = Delegate.create(this, chargeXML);
		// Création du cadre pour l'aperçu
		scene.createEmptyMovieClip("cadre_mc", 8);
		scene.cadre_mc._x = 50;
		scene.cadre_mc._y = 190;
		scene.cadre_mc.loadMovie("images/cadre.jpg");
		// Création du clip pour l'image
		scene.createEmptyMovieClip("apercu_mc", 9);
		scene.apercu_mc._x = 50+12;
		scene.apercu_mc._y = 190+16;
		// Affichage de l'aperçu
		traceFiltre();
		//Création du bouton Annuler
		var initObj:Object = new Object();
		initObj.label = "Annuler";
		initObj._x = 160;
		initObj._y = 370;
		initObj._width = 60;
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, annuler);
		scene.createClassObject(Button, "annuler_btn", 10, initObj);
		initObj.label = "Appliquer";
		initObj._x = 230;
		initObj._width = 60;
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, appliquer);
		scene.createClassObject(Button, "valider_btn", 11, initObj);
		initObj.label = "OK";
		initObj._x = 90;
		initObj._width = 60;
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, ok);
		scene.createClassObject(Button, "ok_btn", 12, initObj);
	}
	private function newColor(evt:Object) {
		clActuelle = evt.couleur;
		traceFiltre();
	}
	private function newAlpha(evt:Object) {
		alphaActuel = evt.target.value;
		traceFiltre();
	}
	private function traceFiltre(Void):Void {
		// On remet la bonne couleur au petit carré de choix de la couleur
		scene.chxCol_mc.clAct = this.clActuelle;
		with (scene.chxCol_mc) {
			moveTo(0, 0);
			lineStyle(0, "0x000000", 100);
			beginFill("0x"+this.clActuelle, 100);
			lineTo(20, 0);
			lineTo(20, 20);
			lineTo(0, 20);
			endFill();
		}
		// On applique à l'apercu
		scene.apercu_mc.createEmptyMovieClip("filtre_mc", 2);
		with (scene.apercu_mc.filtre_mc) {
			moveTo(0, 0);
			lineStyle(0, "0x"+this.clActuelle, this.alphaActuel);
			beginFill("0x"+this.clActuelle, this.alphaActuel);
			lineTo(160, 0);
			lineTo(160, 120);
			lineTo(0, 120);
			endFill();
		}
	}
	private function newImage(evt:Object) {
		fondActuel = evt.target.selectedItem.img;
		affVign(evt.target.selectedItem.vign);
	}
	private function affVign(vign:String) {
		scene.apercu_mc.createEmptyMovieClip("image_mc", 1);
		scene.apercu_mc.image_mc.loadMovie(vign);
	}
	private function chargeXML(succes) {
		if (succes) {
			var mesFonds:Array = loadImages.firstChild.childNodes;
			for (var i = 0; i<mesFonds.length; i++) {
				if (fondActuel == mesFonds[i].attributes.img) {
					affVign(mesFonds[i].attributes.vign);
				}
				var initObj:Object = new Object();
				initObj.label = mesFonds[i].attributes.nom;
				initObj.img = mesFonds[i].attributes.img;
				initObj.vign = mesFonds[i].attributes.vign;
				scene.chxImage.addItem(initObj);
			}
		} else {
			trace("Erreur de chargement du XML");
		}
	}
	private function annuler(Void):Void {
		scene._parent.fermer_btn.onRelease();
	}
	private function appliquer(Void):Void {
		scene._parent._parent._parent.monBureau.setParam(clActuelle, alphaActuel, fondActuel);
	}
	private function ok(Void):Void {
		scene._parent._parent._parent.monBureau.setParam(clActuelle, alphaActuel, fondActuel);
		scene._parent.fermer_btn.onRelease();
	}
}
