﻿import mx.utils.Delegate;
import mx.controls.Button;
class ParamDate {
	private var scene:MovieClip;
	private var horloge:MovieClip;
	var maDate:Date;
	private var diffAct:Number;
	public function ParamDate(scen:MovieClip, diff:Number) {
		scene = scen;
		diffAct = diff;
		creerElementFixe();
		// Création du setInterval dans notre objet ParamDate
		setInterval(this, "refaireDate", 1000);
		refaireDate();
		scene.chxDate.selectedDate = maDate;
	}
	private function creerElementFixe(Void):Void {
		// Création du fond de couleur gris
		scene.createEmptyMovieClip("fondGris", 1);
		var fondGris:MovieClip = eval(scene+".fondGris");
		var cl:String = "A0A0A0";
		with (fondGris) {
			moveTo(0, 0);
			lineStyle(0, "0x"+cl, 100);
			beginFill("0x"+cl, 100);
			lineTo(450, 0);
			lineTo(450, 270);
			lineTo(0, 270);
			endFill();
		}
		// Création du DateChooser
		var initObj:Object = new Object();
		initObj._x = 10;
		initObj._y = 10;
		scene.attachMovie("DateChooser", "chxDate", 2, initObj);
		// On francise le DateChosser
		scene.chxDate.firstDayOfWeek = 1;
		scene.chxDate.dayNames = ["D", "L", "M", "M", "J", "V", "S"];
		scene.chxDate.monthNames = ["Janvier", "Février", "Mars", "Avril", "Mai", "Juin", "Juillet", "Août", "Septembre", "Octobre", "Novembre", "Décembre"];
		var monEcouteur:Object = new Object();
		scene.chxDate.addEventListener("change", monEcouteur);
		// Ici on dit que notre change sera la fonction newDate
		//		de notre objet ParamDate, via Delegate.create
		monEcouteur.change = Delegate.create(this, newDate);
		// Création de l'horloge
		scene.createEmptyMovieClip("horloge", 3);
		horloge = eval(scene+".horloge");
		horloge._x = 240+90;
		horloge._y = 10+90;
		// Création et load du fond de l'horloge
		horloge.createEmptyMovieClip("fond", 1);
		horloge.fond.loadMovie("images/horloge.jpg");
		horloge.fond._x = -90;
		horloge.fond._y = -90;
		// Création des aiguilles
		initObj._x = 0;
		initObj._y = 0;
		horloge.attachMovie("aiguilleH", "heure", 2, initObj);
		horloge.attachMovie("aiguilleM", "minute", 3, initObj);
		horloge.attachMovie("aiguilleS", "seconde", 4, initObj);
		// Création des numericStepper
		initObj._x = 260;
		initObj._y = 200;
		initObj._width = 48;
		initObj._height = 22;
		initObj.maximum = 23;
		scene.attachMovie("NumericStepper", "heureStep", 4, initObj);
		var ecoutHeure:Object = new Object();
		// Ici on dit que notre change sera la fonction newHeure
		//		de notre objet ParamDate, via Delegate.create
		ecoutHeure.change = Delegate.create(this, newHeure);
		scene.heureStep.addEventListener("change", ecoutHeure);
		initObj._x = 310;
		initObj._width = 48;
		initObj._height = 22;
		initObj.maximum = 59;
		scene.attachMovie("NumericStepper", "minuteStep", 5, initObj);
		var ecoutMinute:Object = new Object();
		// Ici on dit que notre change sera la fonction newMinute
		//		de notre objet ParamDate, via Delegate.create
		ecoutMinute.change = Delegate.create(this, newMinute);
		scene.minuteStep.addEventListener("change", ecoutMinute);
		initObj._x = 360;
		initObj._width = 48;
		initObj._height = 22;
		initObj.maximum = 59;
		scene.attachMovie("NumericStepper", "secondeStep", 6, initObj);
		var ecoutSeconde:Object = new Object();
		// Ici on dit que notre change sera la fonction newSeconde
		//		de notre objet ParamDate, via Delegate.create
		ecoutSeconde.change = Delegate.create(this, newSeconde);
		scene.secondeStep.addEventListener("change", ecoutSeconde);
		//Création du bouton Annuler
		initObj.label = "Annuler";
		initObj._x = 310;
		initObj._y = 240;
		initObj._width = 60;
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, annuler);
		scene.createClassObject(Button, "annuler_btn", 7, initObj);
		initObj.label = "Appliquer";
		initObj._x = 380;
		initObj._width = 60;
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, appliquer);
		scene.createClassObject(Button, "valider_btn", 8, initObj);
		initObj.label = "OK";
		initObj._x = 240;
		initObj._width = 60;
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, ok);
		scene.createClassObject(Button, "ok_btn", 9, initObj);
	}
	private function refaireDate(Void):Void {
		// On prend la date actuelle
		maDate = new Date();
		// On applique notre différence de secondes
		diffAct = Math.round(diffAct);
		maDate.setTime(maDate.getTime()+diffAct*1000);
		// Mise à jour de l'affichage
		horloge.heure._rotation = (maDate.getHours()/12)*360;
		horloge.minute._rotation = (maDate.getMinutes()/60)*360;
		horloge.seconde._rotation = (maDate.getSeconds()/60)*360;
		scene.heureStep.value = maDate.getHours();
		scene.minuteStep.value = maDate.getMinutes();
		scene.secondeStep.value = maDate.getSeconds();
		if (maDate.getHours() == 0 && maDate.getMinutes() == 0 && maDate.getSeconds() == 0) {
			// On vient de changer de jour, on met à jour le DateChooser
			scene.chxDate.selectedDate = maDate;
		}
	}
	private function newDate(evt:Object) {
		// On affecte à la nouvelle date celle sélectionnée
		var maNewDate:Date = new Date(evt.target.selectedDate);
		// On refait la date de l'user
		refaireDate();
		// On affecte les heures, minutes et secondes à la nouvelle date
		maNewDate.setHours(maDate.getHours(), maDate.getMinutes(), maDate.getSeconds());
		// on récupère l'heure actuelle véritable
		var maActDate:Date = new Date();
		// on fait la différence en secondes entre la date actuelle et la nouvelle date
		diffAct = (maNewDate.getTime()-maActDate.getTime())/1000;
		// on refait notre date
		refaireDate();
		scene.chxDate.selectedDate = maDate;
	}
	private function newHeure(evt:Object) {
		// On calcule la différence d'heure entre celle d'avant et la nouvelle
		var diffHeure:Number = evt.target.value-maDate.getHours();
		// On change la différence diffAct;
		diffAct = diffAct+diffHeure*60*60;
	}
	private function newMinute(evt:Object) {
		// On calcule la différence de minutes entre celle d'avant et la nouvelle
		var diffMinute:Number = evt.target.value-maDate.getMinutes();
		// On change la différence diffAct;
		diffAct = diffAct+diffMinute*60;
	}
	private function newSeconde(evt:Object) {
		// On calcule la différence de secondes entre celle d'avant et la nouvelle
		var diffSeconde:Number = evt.target.value-maDate.getSeconds();
		// On change la différence diffAct;
		diffAct = diffAct+diffSeconde;
	}
	private function annuler(Void):Void {
		scene._parent.fermer_btn.onRelease();
	}
	private function appliquer(Void):Void {
		scene._parent._parent._parent.monBureau.setParamDate(diffAct);
	}
	private function ok(Void):Void {
		scene._parent._parent._parent.monBureau.setParamDate(diffAct);
		scene._parent.fermer_btn.onRelease();
	}
}
