﻿import mx.utils.Delegate;
class VidStream {
	private var scene:MovieClip;
	private var video:String;
	private var monNc:NetConnection;
	private var fluxVideoNs:NetStream;
	private var min:Number;
	private var sec:Number;
	private var inter:Number = 0;
	public function VidStream(scen:MovieClip, vide:String, mi:Number, se:Number) {
		scene = scen;
		video = vide;
		min = mi;
		sec = se;
		var prof:Number = 1;
		// Création de fond gris
		scene.createEmptyMovieClip("fondGris", prof);
		prof++;
		var fondGris:MovieClip = eval(scene+".fondGris");
		var cl:String = "D0D0D0";
		with (fondGris) {
			moveTo(0, 0);
			linestyle(0, "0x"+cl, 100);
			beginFill("0x"+cl, 100);
			lineTo(230, 0);
			lineTo(230, 220);
			lineTo(0, 220);
			endFill();
		}
		var initObj:Object = new Object();
		initObj._x = 0;
		initObj._y = 0;
		// Création de l'objet vidéo
		scene.attachMovie("maVid", "maVid", prof, initObj);
		prof++;
		// Création du bouton play
		scene.attachMovie("play", "play_btn", prof);
		scene.play_btn._x = 20;
		scene.play_btn._y = 202;
		scene.play_btn.onRelease = Delegate.create(this, lecture);
		prof++;
		// Création du bouton pause
		scene.attachMovie("pause", "pause_btn", prof, initObj);
		scene.pause_btn._x = 20;
		scene.pause_btn._y = 202;
		scene.pause_btn.onRelease = Delegate.create(this, arret);
		scene.pause_btn._visible = false;
		prof++;
		// Création du bouton stop
		scene.attachMovie("stop", "stop_btn", prof, initObj);
		scene.stop_btn._x = 56;
		scene.stop_btn._y = 202;
		scene.stop_btn.onRelease = Delegate.create(this, arretC);
		prof++;
		// Paramètre pour le ProgressBar
		initObj._x = 77;
		initObj._y = 188;
		initObj._width = 150;
		initObj._height = 30;
		initObj.label = "Lecture : %3%% ";
		initObj.mode = "manual";
		scene.attachMovie("ProgressBar", "avance", prof, initObj);
		prof++;
		// Paramétrage du streaming
		monNc = new NetConnection();
		monNc.connect(null);
		fluxVideoNs = new NetStream(monNc);
		scene.maVid.maVideo.attachVideo(fluxVideoNs);
		// Definition du destructeur
		scene.detruire = function(Void) {
			this.maVidStream.fluxVideoNs.close();
		};
	}
	private function maj(Void):Void {
		scene.avance.setProgress(fluxVideoNs.time, min*60+sec);
	}
	private function lecture(Void):Void {
		if (inter>0) {
			fluxVideoNs.pause(false);
		} else {
			fluxVideoNs.play(video);
		}
		inter = setInterval(this, "maj", 500);
		scene.play_btn._visible = false;
		scene.pause_btn._visible = true;
	}
	private function arret(Void):Void {
		fluxVideoNs.pause(true);
		clearInterval(inter);
		scene.play_btn._visible = true;
		scene.pause_btn._visible = false;
	}
	private function arretC(Void):Void {
		fluxVideoNs.close();
		clearInterval(inter);
		inter = 0;
		scene.play_btn._visible = true;
		scene.pause_btn._visible = false;
	}
}
