﻿class Fenetre extends MovieClip {
	private var icone:MovieClip;
	private var clip:MovieClip;
	private var barre_mc:MovieClip;
	private var fermer_btn:Button;
	private var cacher_btn:Button;
	private static var ALPHA:Number = 50;
	public function init(ico:MovieClip):Void {
		icone = ico;
		dessus();
		barre_mc.onPress = function(Void) {
			_parent.drag();
		};
		barre_mc.onRelease = function(Void) {
			stopDrag();
			_parent._alpha = 100;
		};
		fermer_btn.onRelease = function(Void) {
			_parent.fermer();
		};
		cacher_btn.onRelease = function(Void) {
			_parent.cacher();
		};
	}
	private function dessus(Void):Void {
		var nivMax:Number = this._parent._parent.getNextHighestDepth()-1;
		var monNiv:Number = this.getDepth();
		if (monNiv<nivMax) {
			this.swapDepths(nivMax);
		}
	}
	private function drag(Void):Void {
		startDrag(this);
		_alpha = ALPHA;
		dessus();
	}
	private function fermer(Void):Void {
		if (this.clip.detruire != undefined) {
			this.clip.detruire();
		}
		icone.monMCL.unloadClip(this.clip);
		this._parent._parent.maBarre.enleverBouton(this);
		removeMovieClip(this);
	}
	private function cacher(Void):Void {
		this.clip._visible = !this.clip._visible;
	}
}
