﻿import mx.utils.Delegate;
/*
modeDessin :
0 : Déplacement ou Suppression
1 : Trait normal
2 : Trait fermé
3 : trait fermé rempli
*/
class Dessin {
	private var scene:MovieClip;
	private var fondDessin:MovieClip;
	private var dessin:MovieClip;
	private var outils:MovieClip;
	private var monEcoutMode:Object;
	private var monEcoutEpaiss:Object;
	private var monEcoutAlpha:Object;
	private var monEcoutTrait:Object;
	private var monEcoutRempl:Object;
	private var dessine:Object;
	private var clTrait:String;
	private var clRempl:String;
	private var alpha:Number;
	private var modeDessin:Number = 1;
	private var epaisseur:Number = 1;
	private var nb:Number = 1;
	private static var CLFOND:String = "EEF1FD";
	private static var CLOUTILS:String = "CCCCCC";
	private static var CLDEFTRAIT:String = "000000";
	private static var CLDEFREMPL:String = "A0A0A0";
	private static var DEFALPHA:Number = 75;
	public function Dessin(scen:MovieClip) {
		scene = scen;
		creerElements();
		// Notre écouteur de dessin
		dessine = new Object();
		Mouse.addListener(dessine);
		// Ici on dit que notre onMouseDown sera la fonction debutDessin
		//		de notre objet Dessin, via Delegate.create
		dessine.onMouseDown = Delegate.create(this, debutDessin);
		// Ici on dit que notre onMouseUp sera la fonction stopDessin
		//		de notre objet Dessin, via Delegate.create
		dessine.onMouseUp = Delegate.create(this, stopDessin);
		var monDessin:Object;
		scene.detruire = function(Void) {
			this.monDessin.detruire();
		};
	}
	private function creerElements(Void):Void {
		// Création du fond de couleur
		scene.createEmptyMovieClip("fondDessin", 1);
		fondDessin = eval(scene+".fondDessin");
		var cl:String = CLFOND;
		with (fondDessin) {
			moveTo(0, 0);
			lineStyle(0, "0x"+cl, 100);
			beginFill("0x"+cl, 100);
			lineTo(550, 0);
			lineTo(550, 400);
			lineTo(0, 400);
			endFill();
		}
		// Création du clip vide pour mettre les dessins
		scene.createEmptyMovieClip("dessin", 2);
		dessin = eval(scene+".dessin");
		// Création du clip outils et dessin du rectangle de couleur
		scene.createEmptyMovieClip("outils", 3);
		outils = eval(scene+".outils");
		outils._x = 550-150;
		outils._y = 10;
		cl = CLOUTILS;
		with (outils) {
			moveTo(0, 0);
			lineStyle(1, "0x000000", 100);
			beginFill("0x"+cl, 100);
			lineTo(140, 0);
			lineTo(140, 190);
			lineTo(0, 190);
			endFill();
		}
		var initObj:Object = new Object();
		// Combobox pour le mode de dessins
		initObj._x = 10;
		initObj._y = 10;
		initObj._width = 120;
		initObj._height = 22;
		outils.attachMovie("ComboBox", "chxModeDessin", 1, initObj);
		outils.chxModeDessin.addItem("Trait normal", 1);
		outils.chxModeDessin.addItem("Trait fermé", 2);
		outils.chxModeDessin.addItem("Trait fermé rempli", 3);
		outils.chxModeDessin.addItem("Déplacement", 4);
		outils.chxModeDessin.addItem("Suppression", 5);
		monEcoutMode = new Object();
		// Ici on dit que notre change sera la fonction chgMode
		//		de notre objet Dessin, via Delegate.create
		monEcoutMode.change = Delegate.create(this, chgMode);
		outils.chxModeDessin.addEventListener("change", monEcoutMode);
		// Taille du trait
		initObj._y += 30;
		outils.createTextField("epais_txt", 2, initObj._x, initObj._y, 100, 22);
		outils.epais_txt.selectable = false;
		outils.epais_txt.text = "Epaisseur :";
		initObj._width = 50;
		initObj._x += 70;
		initObj.value = 1;
		initObj.maximum = 50;
		outils.attachMovie("NumericStepper", "chxEpaisseur", 3, initObj);
		monEcoutEpaiss = new Object();
		// Ici on dit que notre change sera la fonction chgEpais
		//		de notre objet Dessin, via Delegate.create
		monEcoutEpaiss.change = Delegate.create(this, chgEpais);
		outils.chxEpaisseur.addEventListener("change", monEcoutEpaiss);
		// Couleur de trait
		clTrait = CLDEFTRAIT;
		initObj._y += 30;
		initObj._x -= 70;
		outils.createTextField("trait_txt", 4, initObj._x, initObj._y, 100, 22);
		outils.trait_txt.selectable = false;
		outils.trait_txt.text = "Trait :";
		// Création du bouton pour choisir la couleur
		outils.createEmptyMovieClip("chxTrait_mc", 5);
		outils.chxTrait_mc._x = initObj._x+75;
		outils.chxTrait_mc._y = initObj._y;
		dessineCarrTrait();
		// Ecouteur sur le choix de la couleur
		monEcoutTrait = new Object();
		// Ici on dit que notre choix sera la fonction chxClTrait
		//		de notre objet Dessin, via Delegate.create
		monEcoutTrait.choix = Delegate.create(this, chxClTrait);
		// Ici on dit que notre onRelease sera la fonction affChxTrait
		//		de notre objet Dessin, via Delegate.create
		outils.chxTrait_mc.onRelease = Delegate.create(this, affChxTrait);
		// Couleur de remplissage
		clRempl = CLDEFREMPL;
		initObj._y += 30;
		outils.createTextField("rempl_txt", 6, initObj._x, initObj._y, 100, 22);
		outils.rempl_txt.selectable = false;
		outils.rempl_txt.text = "Remplissage :";
		// Création du bouton pour choisir la couleur
		outils.createEmptyMovieClip("chxRempl_mc", 7);
		outils.chxRempl_mc._x = initObj._x+75;
		outils.chxRempl_mc._y = initObj._y;
		dessineCarrRempl();
		// Ecouteur sur le choxi de la couleur
		monEcoutRempl = new Object();
		// Ici on dit que notre choix sera la fonction chxClTrait
		//		de notre objet Dessin, via Delegate.create
		monEcoutRempl.choix = Delegate.create(this, chxClRempl);
		// Ici on dit que notre onRelease sera la fonction affChxTrait
		//		de notre objet Dessin, via Delegate.create
		outils.chxRempl_mc.onRelease = Delegate.create(this, affChxRempl);
		// Alpha du Remplissage
		initObj._y += 30;
		outils.createTextField("alpha_txt", 8, initObj._x, initObj._y, 100, 22);
		outils.alpha_txt.selectable = false;
		outils.alpha_txt.text = "Opacité :";
		initObj._width = 50;
		initObj._x += 70;
		alpha = DEFALPHA;
		initObj.maximum = 100;
		outils.attachMovie("NumericStepper", "chxAlpha", 9, initObj);
		// Si je passe le value dans l'init, ca ne passe pas...
		outils.chxAlpha.value = DEFALPHA;
		monEcoutAlpha = new Object();
		// Ici on dit que notre change sera la fonction chgEpais
		//		de notre objet Dessin, via Delegate.create
		monEcoutAlpha.change = Delegate.create(this, chgAlpha);
		outils.chxAlpha.addEventListener("change", monEcoutAlpha);
		// Bouton exporter en PNG
		initObj.label = "Exporter en PNG";
		initObj.value = undefined;
		initObj._x -= 70;
		initObj._y += 30;
		initObj._width = 120;
		// Ici on dit que notre onRelease sera la fonction annuler
		//		de notre objet Param, via Delegate.create
		initObj.onRelease = Delegate.create(this, exporter);
		outils.attachMovie("Button", "exporter_btn", 10, initObj);
		// Boutons pour cacher la palette d'outils
		initObj._x = 550-20;
		initObj._y = 5;
		initObj._width = 20;
		initObj._height = 20;
		scene.attachMovie("pushButton", "cache_btn", 4, initObj);
		// Ici on dit que notre onRelease sera la fonction affChxTrait
		//		de notre objet Dessin, via Delegate.create
		scene.cache_btn.onRelease = Delegate.create(this, chgOutils);
	}
	private function debutDessin(Void):Void {
		var xmouse:Number = scene._xmouse;
		var ymouse:Number = scene._ymouse;
		if (modeDessin>0 && testoutils() && testzone()) {
			dessin.createEmptyMovieClip("dessin"+nb, nb);
			var clipAct:MovieClip = eval(dessin+".dessin"+nb);
			clipAct.modeDessin = modeDessin;
			clipAct.epaisseur = epaisseur;
			clipAct.clTrait = clTrait;
			clipAct.clRempl = clRempl;
			clipAct.alpha = alpha;
			clipAct.remplir = new Array();
			clipAct.remplir.push(Array(xmouse, ymouse));
			clipAct.moveTo(xmouse, ymouse);
			clipAct.lineStyle(clipAct.epaisseur, parseInt(clTrait, 16), 100);
			// Ici on dit que notre onMouseDown sera la fonction dessinAct
			//		de notre objet Dessin, via Delegate.create
			dessine.onMouseMove = Delegate.create(this, dessinAct);
		}
	}
	private function dessinAct(Void):Void {
		if (testzone()) {
			var xmouse:Number = scene._xmouse;
			var ymouse:Number = scene._ymouse;
			var clipAct:MovieClip = eval(dessin+".dessin"+nb);
			clipAct.remplir.push(Array(xmouse, ymouse));
			clipAct.lineTo(xmouse, ymouse);
		}
	}
	private function stopDessin(Void):Void {
		var clipAct:MovieClip = eval(dessin+".dessin"+nb);
		if (modeDessin == 2) {
			clipAct.lineTo(clipAct.remplir[0][0], clipAct.remplir[0][1]);
		} else if (modeDessin == 3) {
			clipAct.moveTo(clipAct.remplir[0][0], clipAct.remplir[0][1]);
			clipAct.beginFill(parseInt(clipAct.clRempl, 16), clipAct.alpha);
			for (var i = 1; i<clipAct.remplir.length; i++) {
				clipAct.lineTo(clipAct.remplir[i][0], clipAct.remplir[i][1]);
			}
			clipAct.lineTo(clipAct.remplir[0][0], clipAct.remplir[0][1]);
			clipAct.endFill();
		}
		if (modeDessin>0) {
			nb++;
		}
		dessine.onMouseMove = null;
	}
	private function chgMode(Evt:Object):Void {
		var clipAct:MovieClip;
		if (Evt.target.value == 4) {
			// Mode Déplacement
			modeDessin = 0;
			for (var i = 1; i<nb; i++) {
				clipAct = eval(dessin+".dessin"+i);
				clipAct.onPress = function() {
					startDrag(this);
				};
				clipAct.onRelease = function() {
					stopDrag();
				};
			}
		} else if (Evt.target.value == 5) {
			// Mode Suppression
			modeDessin = 0;
			for (var i = 1; i<nb; i++) {
				clipAct = eval(dessin+".dessin"+i);
				clipAct.onRelease = function() {
					removeMovieClip(this);
				};
			}
		} else {
			// Mode de dessin réel
			if (modeDessin == 0) {
				// On avait des actions sur nos clips, donc on les enlèves
				for (var i = 1; i<nb; i++) {
					clipAct = eval(dessin+".dessin"+i);
					clipAct.onPress = null;
					clipAct.onRelease = null;
				}
			}
			// On met notre mode
			modeDessin = Evt.target.value;
		}
	}
	private function chgEpais(Evt:Object):Void {
		epaisseur = Evt.target.value;
	}
	private function chgAlpha(Evt:Object):Void {
		alpha = Evt.target.value;
	}
	private function chgOutils(Void):Void {
		outils._visible = !outils._visible;
	}
	private function dessineCarrTrait(Void):Void {
		var cl:String = "0x"+clTrait;
		with (outils.chxTrait_mc) {
			moveTo(0, 0);
			lineStyle(1, 0x000000, 100);
			beginFill(cl, 100);
			lineTo(20, 0);
			lineTo(20, 20);
			lineTo(0, 20);
			endFill();
		}
	}
	private function dessineCarrRempl(Void):Void {
		var cl:String = "0x"+clRempl;
		with (outils.chxRempl_mc) {
			moveTo(0, 0);
			lineStyle(1, 0x000000, 100);
			beginFill(cl, 100);
			lineTo(20, 0);
			lineTo(20, 20);
			lineTo(0, 20);
			endFill();
		}
	}
	private function affChxTrait(Void) {
		outils.createEmptyMovieClip("choix", 100);
		var choix:MovieClip = eval(outils+".choix");
		var maCouleur:ChxCouleur = new ChxCouleur(choix, outils.chxTrait_mc._x-200, outils.chxTrait_mc._y+25, clTrait);
		maCouleur.addEventListener("choix", monEcoutTrait);
	}
	private function chxClTrait(evt:Object) {
		clTrait = evt.couleur;
		dessineCarrTrait();
	}
	private function affChxRempl(Void) {
		outils.createEmptyMovieClip("choix", 100);
		var choix:MovieClip = eval(outils+".choix");
		var maCouleur:ChxCouleur = new ChxCouleur(choix, outils.chxRempl_mc._x-200, outils.chxRempl_mc._y+25, clRempl);
		maCouleur.addEventListener("choix", monEcoutRempl);
	}
	private function chxClRempl(evt:Object) {
		clRempl = evt.couleur;
		dessineCarrRempl();
	}
	private function testoutils(Void):Boolean {
		var retour:Boolean = true;
		if (outils._xmouse>0 && outils._xmouse<outils._width && outils._ymouse>0 && outils._ymouse<outils._height && outils._visible) {
			retour = false;
		}
		return retour;
	}
	private function testzone(Void):Boolean {
		var retour:Boolean = false;
		if (fondDessin._xmouse>0 && fondDessin._xmouse<fondDessin._width && fondDessin._ymouse>0 && fondDessin._ymouse<fondDessin._height) {
			retour = true;
		}
		return retour;
	}
	private function exporter() {
		if (nb>1) {
			var dessins:Array = new Array();
			var clipAct:MovieClip;
			for (var i = 1; i<nb; i++) {
				clipAct = eval(dessin+".dessin"+i);
				if (clipAct != undefined) {
					// Le clip n'a pas été supprimé, on l'ajoute à notre chaine
					var dessinTab:Array = new Array();
					dessinTab.push(clipAct.modeDessin);
					dessinTab.push(clipAct.epaisseur);
					dessinTab.push(clipAct.clTrait);
					dessinTab.push(clipAct.clRempl);
					dessinTab.push(clipAct.alpha);
					dessinTab.push(clipAct.remplir.join("-"));
					dessins.push(dessinTab.join("_"));
				}
			}
			if (dessins.length>0) {
				getURL("javascript:envForm('"+CLFOND+"','"+dessins.join("@")+"');");
			}
		}
	}
	public function detruire(Void):Void {
		dessine.onMouseDown = undefined;
		dessine.onMouseUp = undefined;
		monEcoutMode = undefined;
		monEcoutEpaiss = undefined;
		monEcoutAlpha = undefined;
		monEcoutTrait = undefined;
		monEcoutRempl = undefined;
	}
}
