﻿import mx.controls.gridclasses.DataGridColumn;
import mx.utils.Delegate;
class Sokobaide {
	private var scene:MovieClip;
	private var monAccordion:MovieClip;
	private var monLoadPhp:XML;
	private var monXml:XML;
	private var monEcouteur:Object;
	public function Sokobaide(scen:MovieClip) {
		scene = scen;
		var initObj:Object = new Object();
		initObj._x = 0;
		initObj._y = 0;
		scene.attachMovie("Accordion", "monAccordion", 1, initObj);
		monAccordion = eval(scene+".monAccordion");
		monAccordion.setSize(550, 400);
		monLoadPhp = new XML();
		monLoadPhp.ignoreWhite = true;
		// Ici on dit que notre onLoad sera la fonction loadScore
		//		de notre objet Sokobaide, via Delegate.create
		monLoadPhp.onLoad = Delegate.create(this, loadScore);
		monXml = new XML();
		monXml.ignoreWhite = true;
		// Ici on dit que notre onLoad sera la fonction loadXml
		//		de notre objet Sokobaide, via Delegate.create
		monXml.onLoad = Delegate.create(this, loadXml);
		monXml.load("accordion.xml");
		monEcouteur = new Object();
		// Ici on dit que notre change sera la fonction ecoutChange
		//		de notre objet Sokobaide, via Delegate.create
		monEcouteur.change = Delegate.create(this, ecoutChange);
		monAccordion.addEventListener("change", monEcouteur);
		scene.detruire = Delegate.create(this, detruire);
	}
	private function ecoutChange(Evt:Object):Void {
		if (monAccordion.selectedIndex == monAccordion.numChildren-1) {
			// On vient sur les scores, on charge le php!
			monLoadPhp.load("scores.php");
		}
	}
	private function loadScore(succes:Boolean):Void {
		if (succes) {
			afficheScores();
		} else {
			trace("Erreur de chargement du Php !");
		}
	}
	private function loadXml(succes:Boolean):Void {
		if (succes) {
			ecrireAccordion();
		} else {
			trace("erreur de chargement du xml");
		}
	}
	private function ecrireAccordion(Void):Void {
		var monNoeud:Array = monXml.firstChild.childNodes;
		var textAct:TextField;
		for (var i = 0; i<monNoeud.length; i++) {
			monAccordion.createChild("texte", "texte"+i, {label:monNoeud[i].attributes.nom});
			textAct = eval(monAccordion+".texte"+i).texte_txt;
			textAct._width = 547;
			textAct.autoSize = true;
			textAct.htmlText = monNoeud[i].firstChild.nodeValue;
		}
		monAccordion.createChild("DataGrid", "scores", {label:"Meilleurs Scores"});
		monAccordion.scores.setSize(548, 335);
		ajtCol(monAccordion.scores, "Rang", 40);
		ajtCol(monAccordion.scores, "Pseudo", 230);
		ajtCol(monAccordion.scores, "Niveau", 50);
		ajtCol(monAccordion.scores, "NbCoups", 60);
		ajtCol(monAccordion.scores, "Date", 130);
	}
	private function ajtCol(grille:MovieClip, nom:String, larg:Number):Void {
		var colonne:DataGridColumn = new DataGridColumn(nom);
		colonne.headerText = nom;
		colonne.width = larg;
		grille.addColumn(colonne);
	}
	private function afficheScores(Void):Void {
		var monScore:MovieClip = monAccordion.scores;
		monScore.removeAll();
		var monNoeud:Array = monLoadPhp.firstChild.childNodes;
		for (var i = 0; i<monNoeud.length; i++) {
			var obj:Object = new Object();
			obj.Rang = i+1;
			obj.Pseudo = monNoeud[i].attributes.pseudo;
			obj.Niveau = monNoeud[i].attributes.niveau;
			obj.NbCoups = monNoeud[i].attributes.nbCoups;
			obj.Date = monNoeud[i].attributes.date;
			monScore.addItem(obj);
		}
	}
	private function detruire(Void):Void {
		for (var i = 0; i<monXml.firstChild.childNodes.length; i++) {
			eval("monAccordion.texte"+i).texte_txt.removeMovieClip();
			eval("monAccordion.texte"+i).removeMovieClip();
		}
		monAccordion.removeEventListener("change", monEcouteur);
		removeMovieClip(eval("monAccordion"));
		monXml.onLoad = null;
		monLoadPhp.onLoad = null;
		monLoadPhp = null;
		monXml = null;
	}
}
